%define oname   bbswitch

Name:		dkms-%{oname}
Summary:	bbswitch - Optimus GPU power switcher
Group:		System/Kernel and hardware
Version:	v0.8
Release:	%mkrel 9
License:	GPLv2+
URL: 	https://github.com/Bumblebee-Project/bbswitch
Source0:	%{oname}-%{version}.tar.xz

Patch0:		bbswitch-v0.8-Makefile.patch
Patch1:		bbswitch-v0.8-proc_ops-struct.patch
Patch2:		bbswitch-v0.8-add-kernel-header.patch
Patch3:		bbswitch-v0.8-kernel-5.18.patch

Requires:	dkms
Requires:   gcc >= 9.2.0

%description
bbswitch is a kernel module which automatically detects the required
ACPI calls for two kinds of Optimus laptops : "real" (e.g. Nvidia GT 425M)
and "legacy" (e.g. Nvidia GT 310M) Optimus laptops.
The universal calls should work for every laptop model supporting either
Optimus calls.

This package uses DKMS to automatically build the bbswitch kernel module.

%files
%doc NEWS README.md
%{_usrsrc}/%{oname}-%{version}-%{release}/*

%post
dkms add -m %{oname} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms build -m %{oname} -v %{version}-%{release} --rpm_safe_upgrade &&
dkms install -m %{oname} -v %{version}-%{release} --rpm_safe_upgrade --force
true
if [ "$1" = 1 ]; then
/sbin/rmmod %{oname} >/dev/null 2>&1
depmod -a
/sbin/modprobe %{oname} >/dev/null 2>&1
echo "%{oname}" >> /etc/modprobe.preload
fi

%preun
dkms remove --binary -m %{oname} -v %{version}-%{release} --rpm_safe_upgrade --all
true
if [ "$1" = 0 ]; then
/sbin/rmmod %{oname} >/dev/null 2>&1
sed -i '/%{oname}/ d' /etc/modprobe.preload
fi


#--------------------------------------------------------------------
%prep
%setup -qn %{oname}-%{version}
%apply_patches
#sed -i 's/#MODULE_VERSION#/%{version}-%{release}/g' dkms/dkms.conf
#sed -i 's/KVERSION=$kernelver/KVERSION=$kernelver SKIP_STACK_VALIDATION=1/g' dkms/dkms.conf
%install
mkdir -p %{buildroot}%{_usrsrc}/%{oname}-%{version}-%{release}
cp %{oname}.c %{buildroot}%{_usrsrc}/%{oname}-%{version}-%{release}
cp Makefile %{buildroot}%{_usrsrc}/%{oname}-%{version}-%{release}
#cp dkms/dkms.conf %{buildroot}%{_usrsrc}/%{oname}-%{version}-%{release}/dkms.conf
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{oname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{oname}"
PACKAGE_VERSION="%{version}-%{release}"
MAKE[0]="export IGNORE_CC_MISMATCH=1; 'make' SKIP_STACK_VALIDATION=1"
CLEAN="make clean"
BUILT_MODULE_NAME[0]="%{oname}"
BUILT_MODULE_LOCATION="./"
DEST_MODULE_LOCATION[0]="/kernel/drivers/acpi"
AUTOINSTALL="yes"
EOF


%changelog
* Tue Jun 07 2022 onkelho <oh.quait at gmail.com> - 0.8-9pclos2022
- rebuild 
- - add patch3 kernel-5.18  Thanks goes to Archlinux

* Mon Jan 31 2022 onkelho <oh.quait at gmail.com> - 0.8-8pclos2022
- updates kerv-5.17
- add export IGNORE_CC_MISMATCH=1;

* Wed Sep 29 2021 onkelho <oh.quait at gmail.com> - 0.8-7pclos2021
- rebuild

* Wed Jun 08 2020 onkelho <oh.quait at gmail.com> - 0.8-6pclos2020
- rebuild add patch kernel-header

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - v0.8-5pclos2020
- rebuild - fix proc-ops-struct, kernel-5.6...

* Mon Mar 30 2020 onkelho <oh.quait at gmail.com> - v0.8-4pclos2020
- rebuild against updates

* Tue Aug 13 2019 tex - v0.8-3pclos2019
- rebuild against updates

* Sat Oct 20 2018 onkelho <oh.quait at gmail.com> - v0.8-2pclos2018
- rebuild --fixed linux/uaccess.h from git branch develop
- build as x86_64, dkms.conf by eof

* Thu May 29 2014 bb >bb> v0.8-1pclos2014
- update
